<?php
/*
    Error Track - GuppY PHP Script - version 4.5
    CeCILL Copyright (C) 2004-2005 by Laurent Duveau
    Initiated by Laurent Duveau and Nicolas Alves,
    followed by Albert Aymard, Jean Michel Misrachi and all the Team
      Web site = http://www.freeguppy.org/
      e-mail   = info@aldweb.com

    Version History :
      v2.1 (10 March 2003)     : initial release
      v2.4 (24 September 2003) : secured transfered parameters
      v3.0 (25 February 2004)  : removed handling of Error code 500 as the webservers usually do not handle it correctly!
      v4.5 (22 April 2005)     : new complete release (by Jean-Mi)
*/

header("Pragma: no-cache");
define("CHEMIN", "");
include("inc/includes.inc");

if (!empty($err)){
  $err = strip_tags($err);
  $with_mail = "false";
  
  if (!is_numeric($err)) {
    die('STOP ! $err is not numeric ('.$err.')');
  }
  
  $ip = explode('.', $REMOTE_ADDR);
  if (count($ip) != 4) die('STOP ! Bad IP ('.$REMOTE_ADDR.')');
  foreach($ip as $n) {
    if ($n < 0 || $n > 255) die('STOP ! Bad IP ('.$REMOTE_ADDR.')');
  }
  
  if ($err < 0) {
    $with_mail = "true";
    $err = abs($err);
  }

  $fichiers = array();
  if ($hd = opendir(DATAREP."error")) {
    while ($fichier = readdir($hd)) {
      if (stristr($fichier, INCEXT) == TRUE ) {
        $fichiers[] = $fichier;
      }
    }
    closedir($hd);
  }
  $max_fic = 20;
  if (isset($serviz[50]) && ($serviz[50] > 0)) $max_fic = $serviz[50];
  $min_fic = max(0, $max_fic - 10);
  if (count($fichiers) > $max_fic) {
    for ($i=0; $i < count($fichiers) - $min_fic; $i++) {
      DestroyDBFile(DATAREP."error/".$fichiers[$i]);
    }
  }
  
  $msg['400'] = array(
  "Bad Request",
  "The HTTP request could not be understood by the server due to malformed syntax.",
  "The web browser may be too recent, or the HTTP server may be too old." );
  $msg['401'] = array(
    "Unauthorized",
    "The request requires user authentication",
    "" );
  $msg['403'] = array(
    "Forbidden",
    "The HTTP server understood the request, but it is refusing to fulfill it.",
    "This status code is commonly used when the server does not wish to reveal exactly why the request has been refused, or when no other response is applicable (for example the server is an Intranet and only LAN machines are authorized to connect)." );
  $msg['404'] = array(
    "Not found",
    "The server has not found anything matching the request address (URI).",
    "This means the URL you have typed or clicked on is wrong or obsolete and does not match any document existing on the server (you may try to gradualy remove the URL components from de right to the left to eventualy retrieve an existing path)." );
  $msg['500'] = array(
    "Internal server error",
    "The HTTP server encountered an unexpected condition which prevented it from fulfilling the request.",
    "For example this error can be caused by a server misconfiguration, or a resource exhausted or denied to the server on the host machine." );

  $msg0 = $msg[$err][0];
  $msg1 = $msg[$err][1];
  $msg2 = $msg[$err][2];
  if (empty($msg0)) { 
      $msg0 = "Unattended error";
      $msg1 = "Unattended error";
      $msg2 = "See the <a href='http://www.apachefrance.com/Articles/7/page2.html' alt=''>errors code HTTP</a>.";
  }
  $date = date("d/m/Y H:i");
  $dest = $REQUEST_URI.(empty($REQUEST_QUERY_STRING)?"":"?".$REQUEST_QUERY_STRING);
  $domaine = gethostbyaddr($REMOTE_ADDR);

$err=addslashes($err);
$dest=strip_tags(addslashes($dest));
$HTTP_REFERER=strip_tags(addslashes($HTTP_REFERER));
$HTTP_USER_AGENT = strip_tags(addslashes($HTTP_USER_AGENT));


$mettre = "<?php
\$err = \"$err\";
\$msg0 = \"$msg0\";
\$msg1 = \"$msg1\";
\$msg2 = \"$msg2\";
\$date = \"Date : $date\";
\$dest = \"Page requested : $dest\";
\$source = \"Page source : $HTTP_REFERER\";
\$browser = \"Browser : $HTTP_USER_AGENT\";
\$addr_ip = \"IP address : $REMOTE_ADDR\";
\$domaine = \"Domaine : $domaine\";
\$with_mail = $with_mail;
?>"; 

  $id = date('Ymd_His_').$err;
  WriteFullDB(DATAREP."error/".$id.INCEXT, $mettre);

  header("location:".$site[3]."error.php?id=".$id);
}
else {
  $id = strip_tags($id);

  if (!is_file(DATAREP."error/".$id.INCEXT)) die('STOP ! No file !');

  include(DATAREP."error/".$id.INCEXT);

  $topmess = "Error ".$err." : ".$msg0;
  include("inc/hpage.inc");
  htable($topmess, "100%");
  echo "<b>".$msg1."</b><br />".$msg2;
  echo "<hr /><b>Context of the error</b><br />".$dest."<br />".$source."<br />".$browser."<br />".$addr_ip."<br />".$domaine;
    
  if ($with_mail) {
    eMailHtmlTo(
      $site[0]." : ERROR ".$err, 
      "Site : ".$site[0]."<br />ERROR ".$err." : ".$msg0."<br />".$date."<br />".$dest."<br />".$source."\n".$browser."<br />".$addr_ip."<br />".$domaine,
      "");
    echo "<br /><b>This context is recorded and communicated to the webmaster.</b>";
  }
  btable();
  include("inc/bpage.inc");
}
?>
